package com.ynet.life.servlet;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.ynet.gene.core.GENEConstance;
import com.ynet.life.base.Trace;
import com.ynet.util.algorithm.RandomStringUtils;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.GraphicsEnvironment;
import java.awt.Stroke;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Random;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/* loaded from: com_ynet_life_servlet.jar:com/ynet/life/servlet/VerifyImageTwoDisplayServlet.class */
public class VerifyImageTwoDisplayServlet extends HttpServlet {
    private static final long serialVersionUID = 20100130162901L;
    private static List<String> fonts = new ArrayList();

    public VerifyImageTwoDisplayServlet() {
        initFonts();
    }

    private void initFonts() {
        GraphicsEnvironment.getLocalGraphicsEnvironment().preferLocaleFonts();
        for (String s : GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames(Locale.CHINA)) {
            char c = s.charAt(0);
            if (!Character.isLowerCase(c) && !Character.isUpperCase(c)) {
                fonts.add(s);
            }
        }
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) {
        String verifyStr = RandomStringUtils.random(4, "0-9|A-Z", "");
        request.getSession().setAttribute("verifyObj", verifyStr);
        ServletOutputStream e = null;
        try {
            try {
                e = response.getOutputStream();
                response.setHeader("Pragma", "no-cache");
                response.setHeader("Cache-Control", "no-cache");
                response.setDateHeader("Expires", 0L);
                response.setContentType("image/jpeg");
                genGraphics(verifyStr, e);
                e.flush();
                if (e != null) {
                    try {
                        e.close();
                    } catch (IOException e2) {
                        e = e2;
                        Trace.logWarning(GENEConstance.GENE_MVC, "HTTP数据流对象关闭异常", e);
                    }
                }
            } catch (Throwable th) {
                if (e != null) {
                    try {
                        e.close();
                    } catch (IOException ex) {
                        Trace.logWarning(GENEConstance.GENE_MVC, "HTTP数据流对象关闭异常", ex);
                    }
                }
                throw th;
            }
        } catch (IOException ex2) {
            Trace.logError(GENEConstance.GENE_MVC, "图形验证码生成出错", ex2);
            if (e != null) {
                try {
                    e.close();
                } catch (IOException ex3) {
                    Trace.logWarning(GENEConstance.GENE_MVC, "HTTP数据流对象关闭异常", ex3);
                }
            }
        }
    }

    public static void genGraphics(String exPwd, OutputStream out) throws IOException {
        BufferedImage image = new BufferedImage(60, 20, 1);
        Graphics2D graphic = image.createGraphics();
        new Color(1722486);
        Random random = new Random();
        graphic.setColor(Color.white);
        graphic.fillRect(0, 0, 60, 20);
        Font font = new Font("Times New Roman", 0, 18);
        graphic.setFont(font);
        graphic.setColor(getRandColor(160, 200));
        for (int i = 0; i < 20; i++) {
            int x = random.nextInt(60);
            int y = random.nextInt(20);
            int xl = random.nextInt(12);
            int yl = random.nextInt(12);
            graphic.setColor(new Color((int) (Math.random() * 2.68435455E8d)));
            graphic.setStroke(getStroke());
            graphic.setFont(new Font(fonts.get((int) (Math.random() * fonts.size())), getFace(), 18));
            graphic.drawLine(x, y, x + xl, y + yl);
        }
        for (int i2 = 0; i2 < 4; i2++) {
            String rand = RandomStringUtils.random(1, "0-9|A-Z", "");
            graphic.setFont(new Font(fonts.get((int) (Math.random() * fonts.size())), getFace(), 18));
            graphic.setColor(Color.blue);
            graphic.drawString(rand, (i2 * 13) + 6, 16);
        }
        JPEGCodec.createJPEGEncoder(out).encode(image);
    }

    private static Stroke getStroke() {
        return new BasicStroke((float) (Math.random() * 3.0d));
    }

    private static Color getRandColor(int fc, int bc) {
        Random random = new Random();
        if (fc > 255) {
            fc = 255;
        }
        if (bc > 255) {
            bc = 255;
        }
        int r = fc + random.nextInt(bc - fc);
        int g = fc + random.nextInt(bc - fc);
        int b = fc + random.nextInt(bc - fc);
        return new Color(r, g, b);
    }

    private static int getSize() {
        int[] sizes = new int[20];
        for (int i = 0; i < 20; i++) {
            sizes[i] = i + 10;
        }
        return sizes[(int) (Math.random() * 20.0d)];
    }

    private static int getFace() {
        if (Math.random() * 10.0d > 5.0d) {
            return 1;
        }
        return 2;
    }
}
